Index: sounds/Makefile
===================================================================
--- sounds/Makefile	(revision 246862)
+++ sounds/Makefile	(working copy)
@@ -139,13 +139,13 @@
 	touch $@
 
 asterisk-core-%.tar.gz: have_download
-	@if test ! -f $@ && test ! -f $(SOUNDS_DIR)/.$(subst .tar.gz,,$@) ; then $(DOWNLOAD) $(WGET_ARGS) $(SOUNDS_URL)/$@;fi
+	@if test ! -f $@ ; then $(DOWNLOAD) $(WGET_ARGS) $(SOUNDS_URL)/$@;fi
 
 asterisk-extra-%.tar.gz: have_download
-	@if test ! -f $@ && test ! -f $(SOUNDS_DIR)/.$(subst .tar.gz,,$@) ; then $(DOWNLOAD) $(WGET_ARGS) $(SOUNDS_URL)/$@;fi
+	@if test ! -f $@ ; then $(DOWNLOAD) $(WGET_ARGS) $(SOUNDS_URL)/$@;fi
 
 asterisk-moh-%.tar.gz: have_download
-	@if test ! -f $@ && test ! -f $(MOH_DIR)/.$(subst .tar.gz,,$@) ; then $(DOWNLOAD) $(WGET_ARGS) $(SOUNDS_URL)/$@;fi
+	@if test ! -f $@ ; then $(DOWNLOAD) $(WGET_ARGS) $(SOUNDS_URL)/$@;fi
 
 dist-clean:
 	rm -f *.tar.gz
Index: main/xmldoc.c
===================================================================
--- main/xmldoc.c	(revision 246862)
+++ main/xmldoc.c	(working copy)
@@ -1864,20 +1864,55 @@
 	ast_register_atexit(xmldoc_unload_documentation);
 
 	/* Get every *-LANG.xml file inside $(ASTDATADIR)/documentation */
+	globbuf.gl_offs = 0;    /* initialize it to silence gcc */
+#if !defined(HAVE_GLOB_NOMAGIC) || !defined(HAVE_GLOB_BRACE)
+	{
+		int glob_flags = 0;
+		const char *patterns[] = {
+			"%s/documentation/thirdparty/*-%s.xml",
+			"%s/documentation/*-%s.xml",
+			"%s/documentation/thirdparty/*-%.2s_??.xml",
+			"%s/documentation/*-%.2s_??.xml",
+			"%s/documentation/thirdparty/*-%s.xml",
+			"%s/documentation/*-%s.xml"
+		};
+		const char *args[] = {
+			ast_config_AST_DATA_DIR, documentation_language,
+			ast_config_AST_DATA_DIR, documentation_language,
+			ast_config_AST_DATA_DIR, documentation_language,
+			ast_config_AST_DATA_DIR, documentation_language,
+			ast_config_AST_DATA_DIR, default_documentation_language,
+			ast_config_AST_DATA_DIR, default_documentation_language
+		};
+		for (i = 0; i < (sizeof(patterns) / sizeof(const char*)); ++i) {
+			ast_asprintf(&xmlpattern, patterns[i], args[i * 2], args[i * 2 + 1]);
+			globret = glob(xmlpattern, glob_flags, NULL, &globbuf);
+			glob_flags |= GLOB_APPEND;
+
+			if (globret == GLOB_NOSPACE || globret == GLOB_ABORTED) {
+			    break;
+			}
+			ast_free(xmlpattern);
+			xmlpattern = NULL;
+		}
+	}
+#else
 	ast_asprintf(&xmlpattern, "%s/documentation{/thirdparty/,/}*-{%s,%.2s_??,%s}.xml", ast_config_AST_DATA_DIR,
 			documentation_language, documentation_language, default_documentation_language);
-	globbuf.gl_offs = 0;    /* initialize it to silence gcc */
-	globret = glob(xmlpattern, MY_GLOB_FLAGS, NULL, &globbuf);
+	globret = glob(xmlpattern, GLOB_NOMAGIC | GLOB_BRACE, NULL, &globbuf);
+#endif
 	if (globret == GLOB_NOSPACE) {
 		ast_log(LOG_WARNING, "Glob Expansion of pattern '%s' failed: Not enough memory\n", xmlpattern);
 		ast_free(xmlpattern);
 		return 1;
-	} else if (globret  == GLOB_ABORTED) {
+	} else if (globret == GLOB_ABORTED) {
 		ast_log(LOG_WARNING, "Glob Expansion of pattern '%s' failed: Read error\n", xmlpattern);
 		ast_free(xmlpattern);
 		return 1;
 	}
-	ast_free(xmlpattern);
+	if (xmlpattern != NULL) {
+		ast_free(xmlpattern);
+	}
 
 	AST_RWLIST_WRLOCK(&xmldoc_tree);
 	/* loop over expanded files */
